<?php

namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\CdaService;
use SM\Traits\TResponse;

class CdaController extends SMCrud
{
    use TResponse;
    
    protected $CdaService;
    
    public function __construct($crudService, $environment, CdaService $CdaService)
    {
        parent::__construct($crudService, $environment);
        $this->CdaService = $CdaService;
    }
    
    public function getCda(Request $request)
    {
        try {
            $data = $this->CdaService->getCda($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFuncionarios(Request $request)
    {
        try {
            $data = $this->CdaService->getFuncionarios($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFuncionarioLogado(Request $request)
    {
        try {
            $data = $this->CdaService->getFuncionarioLogado($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getPeriodoApuraPonto(Request $request)
    {
        try {
            $data = $this->CdaService->getPeriodoApuraPonto($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarTipoLocalAtendimento(DTO\Request $request)
    {
        try {
            $this->CdaService->salvarTipoLocalAtendimento($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function deletarTipoLocalAtendimento(DTO\Request $request)
    {
        try {
            $this->CdaService->deletarTipoLocalAtendimento($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
