<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class CdaFactory
{

    use TQuery;

    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getCda(array $params)
    {        
        $sql = "SELECT SERV.CDFILIAL,
                       TO_CHAR(DATA.DTDATA, 'DD/MM/YYYY') AS DATA,
                       DECODE(FERI.DTFERIFILI, NULL, 'S', 'N') AS IDDIAUTIL,
                       TO_CHAR(NVL(SERV.DTSERVPREST, DATA.DTDATA), 'DD/MM/YYYY') DTSERVPREST,
                       DATA.NMFUNC,
                       CASE WHEN PROS.CDPROSPECT IS NULL THEN CLIE.NMRAZSOCCLIE ELSE PROS.NMRAZSOCPROS END AS NMCLIEPROSP,
                       INTC.CDINTECLIE,
                       INTP.CDINTEPROS,
                       CASE WHEN PROS.CDPROSPECT IS NULL THEN INTC.NRTEL1INCLIE ELSE INTP.NRTEL1INPROS END AS NRTELINTCLPR,
                       CASE WHEN PROS.CDPROSPECT IS NULL THEN INTC.DSEMAILICLIE ELSE INTP.DSEMAILIPROS END AS DSEMAILINTCLPR,
                       CASE WHEN PROS.CDPROSPECT IS NULL THEN CLIE.NRPARCNEGOCIO ELSE PROS.NRPARCNEGOCIO END AS NRPARCNEGOCIO,
                       CLIE.NMFANTCLIE,
                       CLIE.NMRAZSOCCLIE,
                       PROS.NMFANTPROS,
                       PROS.NMRAZSOCPROS,
                       NVL(SERV.DSREFERENCIA, 'CDA - '||TO_CHAR(DATA.DTDATA, 'DD/MM/YYYY')) AS DSREFERENCIA,
                       DATA.CDEMPRESA,
                       DATA.CDFUNC,
                       SERV.CDCLIENTE,
                       PROS.CDPROSPECT,
                       SERV.NMINTCLIENTE,
                       SERV.NRLICENCAUSO,
                       LUSO.NMFANTLUSO,
                       CLIE.NRINSJURCLIE,
                       SERV.NRSERVCONT,
                       SERV.NRSEQAGESERV,
                       SERV.CDTIPOSERV,
                       TPSV.NMTIPOSERV,
                       SERV.IDSERVPREST AS IDSERVPREST_IN_GRID,
                       SERV.IDSERVPREST,
                       SERV.DTENTRADA,
                       DECODE(SERV.IDSERVPREST, 'FALTA_NAO_JUSTIFICADA', 'S', 'N') AS IDFALTA,
                       SERV.NRPROPOSFAS,
                       SERV.NRVERPROPFAS,
                       SERV.NRSEQUCHT,
                       NVL(SERV.IDSITSERVPREST,'P') AS IDSITSERVPREST,
                       PRO.CDPROJETO,
                       PRO.NMPROJETO,
                       NVL(SERV.NRSERVPREST, '00000') AS NRSERVPREST,
                       SERV.NRMOTIVOEXCEFREQ,
                       DECODE(PROP.NRPROPOSFAS, NULL, NULL, PROP.NRPROPOSFAS||'-'||PROP.NRVERPROPFAS) AS NR_VER_PROP,
                       PROP.DSREFEPROPOSFAS,
                       DATA.CDOPERADOR,
                       INTC.NMINTECLIE,
                       INTP.NMINTEPROS,
                       CONT.NRSEQCONTATO AS NRCONTATO,
                       CONT.DSREFECONT,
                       CONT.CDMOTICONT,
                       CONT.CDSISTEMA,
                       MOTC.NMMOTICONT,
                       EVOC.CDMOTIEVOCON,
                       MEVC.NMMOTIEVOCON,
                       EVOC.DSEVOLCONT,
                       EVOC.DTHREVOLCONT,
                       DECODE(DSSP.NRSERVPREST, NULL, 'N', 'S') AS IDDESCRICAOOK,
                       'S' AS IDATIVO,
                       PER.PERMISSAO,
                       DECODE(SERV.IDSERVPREST, NULL, 'N', 'S') AS IDEXISTSCDA,
                       CASE WHEN TRUNC(SYSDATE) - TRUNC(DATA.DTDATA) > 7
                            THEN 'S'
                            ELSE 'N' END AS IDLIMITEDIAS
                      FROM (SELECT :CDFILIAL AS CDFILIAL, FUNC.CDFILIALOCFUNC, FUNC.NRORG, FUNC.CDEMPRESA,  FUNC.CDFUNC, FUNC.NMFUNC, OPER.CDOPERADOR, DATA.DTDATA
                              FROM DATA, FUNCIONARIO FUNC, OPERADOR OPER
                             WHERE DATA.DTDATA BETWEEN TO_DATE(:DTINICIALPERIODO, 'DD/MM/YYYY') AND TO_DATE(:DTFINALPERIODO, 'DD/MM/YYYY')
                               AND FUNC.CDEMPRESA = :CDEMPRESA
                               AND FUNC.CDFUNC = :CDFUNC
                               AND FUNC.NRORG = :NRORG
                               AND FUNC.NRORG = OPER.NRORG
                               AND FUNC.CDEMPRESA = OPER.CDEMPRESA
                               AND FUNC.CDFUNC = OPER.CDFUNC) DATA,
                           SERVPREST SERV, CLIENTE CLIE, PROJETO PRO, FERIFILI FERI, PROSPECT PROS, LICENCAUSO LUSO, PROPOSTAFAS PROP, 
                           TIPOSERV TPSV, INTECLIE INTC, INTEPROSP INTP, CONTATO CONT, EVOLCONT EVOC, MOTICONT MOTC, MOTIEVOLCONT MEVC,
                           DESCSERVPRES DSSP,
                           (SELECT COUNT(*) AS PERMISSAO
                              FROM AUTGRUPOP
                             WHERE (IDAUTGRUPOP = 'DPAP' OR IDAUTGRUPOP = 'ACSA')
                               AND CDGRUPOPER IN (SELECT CDGRUPOPER
                                                    FROM OPERGRUPOP
                                                   WHERE CDOPERADOR = :CDOPERADOR)) PER
                     WHERE DATA.NRORG = SERV.NRORG(+)
                       AND DATA.CDEMPRESA = SERV.CDEMPRESA(+)
                       AND DATA.CDFUNC = SERV.CDFUNC(+)
                       AND DATA.DTDATA = SERV.DTSERVPREST(+)
                       AND DATA.NRORG = FERI.NRORG(+)
                       AND DATA.CDFILIALOCFUNC = FERI.CDFILIAL(+)
                       AND DATA.DTDATA = FERI.DTFERIFILI(+)
                       AND SERV.NRORG = CLIE.NRORG(+)
                       AND SERV.CDCLIENTE = CLIE.CDCLIENTE(+)
                       AND SERV.NRORG = PRO.NRORG(+)
                       AND SERV.CDPROJETO = PRO.CDPROJETO(+)
                       AND SERV.NRORG = PROS.NRORG(+)
                       AND SERV.CDPROSPECT = PROS.CDPROSPECT(+)
                       AND SERV.NRORG = LUSO.NRORG(+)
                       AND SERV.CDCLIENTE = LUSO.CDCLIENTE(+)
                       AND SERV.NRLICENCAUSO = LUSO.NRLICENCAUSO(+)
                       AND SERV.NRORG = PROP.NRORG(+)
                       AND SERV.NRPROPOSFAS = PROP.NRPROPOSFAS(+)
                       AND SERV.NRVERPROPFAS = PROP.NRVERPROPFAS(+)
                       AND SERV.NRORG = TPSV.NRORG(+)
                       AND SERV.CDTIPOSERV = TPSV.CDTIPOSERV(+)
                       AND SERV.NRORG = INTC.NRORG(+)
                       AND SERV.CDCLIENTE = INTC.CDCLIENTE(+)
                       AND SERV.CDINTECLIE = INTC.CDINTECLIE(+)
                       AND SERV.NRORG = INTP.NRORG(+)
                       AND SERV.CDPROSPECT = INTP.CDPROSPECT(+)
                       AND SERV.CDINTEPROS = INTP.CDINTEPROS(+)
                       AND SERV.NRORG = CONT.NRORG(+)
                       AND SERV.NRCONTATO = CONT.NRSEQCONTATO(+)
                       AND SERV.NRORG = EVOC.NRORG(+)
                       AND SERV.NRCONTATO = EVOC.NRSEQCONTATO(+)
                       AND SERV.DTHREVOLCONT = EVOC.DTHREVOLCONT(+)
                       AND SERV.CDEMPRESA = DSSP.CDEMPRESA(+)
                       AND SERV.CDFUNC = DSSP.CDFUNC(+)
                       AND SERV.CDCLIENTE = DSSP.CDCLIENTE(+)
                       AND SERV.DTSERVPREST = DSSP.DTSERVPREST(+)
                       AND SERV.NRSERVPREST = DSSP.NRSERVPREST(+)
                       AND SERV.NRORG = DSSP.NRORG(+)
                       AND CONT.NRORG = MOTC.NRORG(+)
                       AND CONT.CDMOTICONT = MOTC.CDMOTICONT(+)
                       AND EVOC.NRORG = MEVC.NRORG(+)
                       AND EVOC.CDMOTIEVOCON = MEVC.CDMOTIEVOCON(+)
                       AND :CDFUNC = :CDFUNC
                    ORDER BY TO_DATE(DATA, 'DD/MM/YYYY'), SERV.NRSERVPREST";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getFuncionarios()
    {
        
        $sql = "SELECT
                    OPER.CDOPERADOR,
                    OPER.NMOPERADOR,
                    FUNC.CDFUNC,
                    FUNC.NRORG,
                    FUNC.CDEMPRESA,
                    FUNC.CDFILIAL
                FROM
                    FUNCIONARIO FUNC,
                    OPERADOR    OPER
                WHERE
                        FUNC.CDFUNC = OPER.CDFUNC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getPeriodoApuraPonto()
    {
        $sql = "SELECT DISTINCT
                    F.DTINICIALAPURAPONTO,
                    TO_CHAR(DTINICIALAPURAPONTO, 'DD/MM/YYYY') || ' - ' || TO_CHAR(DTFINALAPURAPONTO, 'DD/MM/YYYY') || DECODE(F.IDPERIODOAPURAPONTO, 'ABERTO', ' (Período aberto)', ' (Período fechado)') DISPLAY,
                    DECODE(F.IDPERIODOAPURAPONTO, 'ABERTO', '(Em aberto)', '(Fechado)') STATUS,
                    TO_CHAR(DTINICIALAPURAPONTO, 'DD/MM/YYYY') || ',' || TO_CHAR(DTFINALAPURAPONTO, 'DD/MM/YYYY') VALUE
                FROM 
                    FPA_PERIODOAPURAPONTO F
                WHERE 
                    F.DTINICIALAPURAPONTO <= TRUNC(SYSDATE)
                ORDER BY 
                    F.DTINICIALAPURAPONTO DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function salvarTipoLocalAtendimento($parametros)
    {
        $sql = "INSERT INTO TIPOESTRUTURA (
                    NRTIPOESTRUTURA, NMTIPOESTRUTURA, NRORG,
                    DTINCLUSAO,         NRORGINCLUSAO,    CDOPERINCLUSAO, IDATIVO
                )
                VALUES (
                    :NRTIPOESTRUTURA, :NMTIPOESTRUTURA, :NRORG,
                    SYSDATE,             :NRORGINCLUSAO,    :CDOPERINCLUSAO, :IDATIVO
                )";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function atualizarTipoLocalAtendimento($parametros)
    {
        $sql = "UPDATE TIPOESTRUTURA 
                   SET NMTIPOESTRUTURA = :NMTIPOESTRUTURA,
                       CDOPERULTATU = :CDOPERULTATU,
                       NRORGULTATU = :NRORGULTATU,
                       DTULTATU = SYSDATE
                 WHERE NRTIPOESTRUTURA = :NRTIPOESTRUTURA";
        
        $this->connection->executeStatement($sql, $parametros);
    }

    public function deletarTipoLocalAtendimento($parametros)
    {
        $sql = "DELETE FROM TIPOESTRUTURA WHERE NRTIPOESTRUTURA = :NRTIPOESTRUTURA ";
        $this->connection->executeStatement($sql, $parametros);
    }
}
