import { Form } from '@zeedhi/common';
import { Metadata } from '@zeedhi/core';
import {
    ZdForm, ZdRow, ZdSelect,
} from '@zeedhi/vuetify';

export class AtividadeCdaController {
    public expandir({ component }: any) {
        const form = Metadata.getInstance<Form>(component.name.split('_')[1]);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public ativaCampoPorTipoDeLacamento() {
        this.redefinirFormulario();
        const tipoLancamento = Metadata.getInstance<ZdSelect>('tipoLacamento-atividade-cda-tipolacamento').value;
        switch (tipoLancamento) {
            case 'ATIVIDADE_CLIENTE':
                Metadata.getInstance<ZdRow>('row-identificacao-atividade-cliente-cda').isVisible = true;
                Metadata.getInstance<ZdForm>('form-identificacao-atividade-cliente-cda-editLacamento').isVisible = true;
                Metadata.getInstance<ZdRow>('row-registro-de-horas-lancamento-cda').isVisible = true;
                Metadata.getInstance<ZdForm>('form-registro-de-horas-cda-editLacamento').isVisible = true;
                break;
            case 'VISITA_PROSPECT':
                Metadata.getInstance<ZdRow>('row-identificacao-visita-prospect-cda').isVisible = true;
                Metadata.getInstance<ZdForm>('form-identificacao-visita-prospect-cda-editLacamento').isVisible = true;
                Metadata.getInstance<ZdRow>('row-contato-lancamento-cda').isVisible = true;
                Metadata.getInstance<ZdForm>('form-contato-lancamento-cda-editLacamento').isVisible = true;
                Metadata.getInstance<ZdRow>('row-registro-de-horas-lancamento-cda').isVisible = true;
                Metadata.getInstance<ZdForm>('form-registro-de-horas-cda-editLacamento').isVisible = true;
                break;
            case 'RELACIONAMENTO_CLIENTE':
                Metadata.getInstance<ZdRow>('row-identificacao-relacionamento-cliente-cda').isVisible = true;
                Metadata.getInstance<ZdForm>('form-identificacao-relacionamento-cliente-cda-editLacamento').isVisible = true;
                Metadata.getInstance<ZdRow>('row-contato-lancamento-cda').isVisible = true;
                Metadata.getInstance<ZdForm>('form-contato-lancamento-cda-editLacamento').isVisible = true;
                Metadata.getInstance<ZdRow>('row-registro-de-horas-lancamento-cda').isVisible = true;
                Metadata.getInstance<ZdForm>('form-registro-de-horas-cda-editLacamento').isVisible = true;
                break;
            case 'ATIVIDADE_INTERNA':
            case 'FALTA_JUSTIFICADA':
            case 'FERIAS':
                break;
            case 'FALTA_NAO_JUSTIFICADA':
            case 'AFASTAMENTO_INSS':
                Metadata.getInstance<ZdRow>('row-justificativa-lancamento-cda').isVisible = true;
                Metadata.getInstance<ZdForm>('form-justificativa-lacamento-cda-editLacamento').isVisible = true;
                break;
            default:
                break;
        }
    }

    public redefinirFormulario() {
        Metadata.getInstance<ZdRow>('row-identificacao-atividade-cliente-cda').isVisible = false;
        Metadata.getInstance<ZdForm>('form-identificacao-atividade-cliente-cda-editLacamento').isVisible = false;
        Metadata.getInstance<ZdRow>('row-identificacao-visita-prospect-cda').isVisible = false;
        Metadata.getInstance<ZdForm>('form-identificacao-visita-prospect-cda-editLacamento').isVisible = false;
        Metadata.getInstance<ZdRow>('row-contato-lancamento-cda').isVisible = false;
        Metadata.getInstance<ZdForm>('form-contato-lancamento-cda-editLacamento').isVisible = false;
        Metadata.getInstance<ZdRow>('row-identificacao-relacionamento-cliente-cda').isVisible = false;
        Metadata.getInstance<ZdForm>('form-identificacao-relacionamento-cliente-cda-editLacamento').isVisible = false;
        Metadata.getInstance<ZdRow>('row-contato-lancamento-cda').isVisible = false;
        Metadata.getInstance<ZdForm>('form-contato-lancamento-cda-editLacamento').isVisible = false;
        Metadata.getInstance<ZdRow>('row-justificativa-lancamento-cda').isVisible = false;
        Metadata.getInstance<ZdForm>('form-justificativa-lacamento-cda-editLacamento').isVisible = false;
        Metadata.getInstance<ZdRow>('row-registro-de-horas-lancamento-cda').isVisible = false;
        Metadata.getInstance<ZdForm>('form-registro-de-horas-cda-editLacamento').isVisible = false;
    }
}
