import { Metadata } from '@zeedhi/core';
import {
    Form, Modal, ModalService,
} from '@zeedhi/common';
import { ZdRow, ZdText } from '@zeedhi/vuetify';

export class CdaController {
    private modalAdicionar!: Modal;

    private modalAdicinarPorTipo!: Modal;

    public visibilidade: boolean = true;

    public currentRow: any = {};

    public campofilter: any = {};

    get visibilidadeDoFrame() {
        return !this.visibilidade;
    }

    public voltarPaginaInicial() {
        this.visibilidade = true;
    }

    public fecharModal() {
        this.modalAdicionar.hide();
        this.modalAdicionar?.destroy();
    }

    public fecharModalAdicinarPorTipo() {
        this.modalAdicinarPorTipo.hide();
        this.modalAdicinarPorTipo?.destroy();
    }

    public expandir({ component }: any) {
        const form = Metadata.getInstance<Form>(component.name.split('_')[1]);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public visualizarAtividade({ row }: any) {
        this.visibilidade = false;
        this.currentRow = row;
        this.montarInformacoesAtividade();
    }

    public montarInformacoesAtividade() {
        Metadata.getInstance<ZdText>('titulo-agrupamento-info-atividade').text = this.currentRow.DATA;
    }

    public async abrirModalAdicionarAtividade() {
        this.modalAdicionar = await ModalService.createFromJson('sm_cda/Modal/sm_cda_modal_adicionar_atividade_selecao_tipo', true);
        await this.modalAdicionar.show();
    }

    public ativaTab() {
        Metadata.getInstance<ZdRow>('row-informacoesParaatividadeEmCliente-identificacao').isVisible = true;
    }
}
